#!/usr/bin/perl





if(!$ARGV[0] || length($ARGV[0]) == 0){
	print STDERR "INVALID HOST NAME!\n";
	usage();
	exit(-1);
}elsif(!$ARGV[1] || length($ARGV[1]) == 0){
	print STDERR "INVALID SNMP VERSION!\n";
	usage();
	exit(-1);
}elsif($#ARGV < 2){
	print STDERR "NOT ENOUGH ARGUMENTS!\n";
	usage();
	exit(-1);
}

if($ARGV[1] == "1"){
	if(!$ARGV[2] || length($ARGV[2]) == 0){
		print STDERR "Invalid or missing SNMP community name.\n";
		usage();
		exit(-1);
	}
	$output = `/usr/bin/snmpwalk -Oav -v1 -c $ARGV[2] $ARGV[0] .1.3.6.1.4.1.2021.8.1.101.1`;
}elsif($ARGV[1] == "2"){
	if(!$ARGV[2] || length($ARGV[2]) == 0){
                print STDERR "Invalid or missing SNMP community name.\n";
                usage();
                exit(-1);
        }
	$output = `/usr/bin/snmpwalk -Oav -v2c -c $ARGV[2] $ARGV[0] .1.3.6.1.4.1.2021.8.1.101.1`;
}
if($ARGV[1] eq "3"){
	if(!$ARGV[$#ARGV -1] || length($ARGV[$#ARGV -1]) == 0){
                print STDERR "Invalid or missing SNMP username.\n";
                usage();
                exit(-1);
        }elsif(!$ARGV[$#ARGV] || length($ARGV[$#ARGV]) == 0){
                print STDERR "Invalid or missing SNMP password.\n";
                usage();
                exit(-1);
	}elsif($#ARGV < 3){
		print STDERR "NOT ENOUGH ARGUMENTS!\n";
		usage();
		exit(-1);
	}

	# I have to take a count of the ARGV array and reference the next to the last and the last argument for username and password.  
	# This is because if the community string is left blank, it will not be included in the args array, but if it is for some reason
	# filled in, it will still be added.
	$output = `/usr/bin/snmpwalk -Oav -v3 -l auth -u $ARGV[$#ARGV - 1] -a MD5 -A $ARGV[$#ARGV] $ARGV[0] .1.3.6.1.4.1.2021.8.1.101.1`;
}
$output =~ s/STRING: //;
$output =~ s/\"|\.//g;
print $output;




# Function that outputs a usage statement in the event that arguments are invalid or missing.
sub usage(){
	print STDERR "usage: <hostname> <snmp version> [<snmp community string (v1 or v2)> | <snmp username (v3)> <snmp password (v3)>]\n";	
}
